#!/usr/bin/env python

'''
Created on Apr 22, 2012

@author: Jakub Chmelar
'''

# import planetlab from SOI module
from SOI import planetlab

# import system modules
import sys
import json

# parse data from JSON strings
landmark_data = json.loads(sys.argv[1])
target_data = json.loads(sys.argv[2])

# set up dictionaries for landmarks and targets
landmarks = {}
targets = {}

# set up landmarks
for data in landmark_data:
    lm = planetlab.Landmark(data)
    landmarks[lm.hostname] = lm

# set up targets
for data in target_data:
    t = planetlab.Target(data)
    targets[t.hostname] = t

# ping all targets from all landmarks
output = planetlab.MultiPing(targets, landmarks)

# convert output to JSON and print it to pure STDOUT
sys.__stdout__.write(json.dumps(output) + "\n")
