#!/usr/bin/env python

'''
Created on Dec 4, 2011

@author: Jakub Chmelar
'''

import SOI.cartesian, random, pygame

width = 800
height = 600

black = (0, 0, 0)
red = (255, 0, 0)
green = (0, 255, 0)
blue = (0, 0, 255)
cyan = (0, 255, 255)
magenta = (255, 0, 255)
yellow = (255, 255, 0)
white = (255, 255, 255)

def DrawPoint(point, color = black):
    x, y = point.GetXY()
    
    pygame.draw.circle(screen, color, (width/2 + int(x), height/2 + int(y)), 2)

# init screen and fill it with white color
screen = pygame.display.set_mode((width, height))
screen.fill(white)

clk = pygame.time.Clock()
running = True

# -------------------------
            
# until closed
while running:
    for event in pygame.event.get():
        if(event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE):
            running = False

        if(event.type == pygame.KEYDOWN and event.key == pygame.K_SPACE):
            # wipe screen
            screen.fill(white)
                
            # ------------------------
            
            # get few random circles
            # circle list
            circles = []
            
            count = random.randint(5, 30)
            for i in range(count):
                # randomize coordinates
                x = random.randint(-100, 100)
                y = random.randint(-100, 100)
                r = random.randint(100, 500)
            
                # get circle
                centre = SOI.cartesian.Point(x, y)
                circle = SOI.cartesian.Circle(centre, r)
            
                pygame.draw.circle(screen, green, (width/2 + int(x), height/2 + int(y)), r, 1)

                pygame.display.flip()
                
                # save it into list
                circles.append(circle)
                
                
            # -------------------------
            
            # now get intersections for these circles
            intersections = SOI.cartesian.GlobalIntersection(circles)
            
            for i in intersections:
                DrawPoint(i.point, red)

                pygame.display.flip()
                clk.tick(40)           
                        
            polygon = SOI.cartesian.IntersectionsToPolygon(circles, intersections)

            if(polygon):
                for p in polygon:
                    DrawPoint(p, blue)
                            
                    pygame.display.flip()
                    clk.tick(40)           

                area = SOI.cartesian.PolygonArea(polygon)
                centroid = SOI.cartesian.PolygonCentroid(polygon)
                p = centroid.GetXY()
                
                print "area = %.2f square units" % area
                print "centroid: x = %.2f, y = %.2f" % (p[0], p[1])
                
                DrawPoint(centroid, magenta)          
                pygame.display.flip()
